using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace MixinSample
{
    class ImageButtonModule : ButtonBase
    {
        //! mixin ImageButtonModule start
        #region tB[h
        private PropertyInfo checkedPropertyInfo = null;
        private bool isHovered = false;
        private bool isChecked = false;
        #endregion

        #region \bh
        /// <summary>
        /// RXgN^łB
        /// </summary>
        public void ImageButtonModuleConstructor()
        {
            // MouseEnter Cxgɏǉ܂B
            MouseEnter += delegate
            {
                // zo[Ԃ\tO𗧂Ă܂B
                isHovered = true;
                // ĕ`悷B
                Invalidate();
            };
            // MouseLeave Cxgɏǉ܂B
            MouseLeave += delegate
            {
                // zo[Ԃ\tO𗎂Ƃ܂B
                isHovered = false;
                // ĕ`悵܂B
                Invalidate();
            };

            // Checked vpeB擾܂B
            checkedPropertyInfo = GetType().GetProperty("Checked");
            // Checked vpeB݂Ȃ΁A
            if (checkedPropertyInfo != null)
            {
                // CheckedChanged Cxg擾܂B
                EventInfo checkedEventInfo = GetType().GetEvent("CheckedChanged");
                // CheckedChanged Cxgɏǉ܂B
                checkedEventInfo.AddEventHandler(this, new EventHandler(delegate
                {
                    // `FbNԂ\tO擾܂B
                    isChecked = (bool)checkedPropertyInfo.GetValue(this, null);
                    // ĕ`悵܂B
                    Invalidate();
                }));
            }
        }

        /// <summary>
        /// Ԃɕ`悷ׂC[WԂ܂B
        /// </summary>
        /// <returns>`悷ׂC[WB</returns>
        private Image GetImage()
        {
            // `FbNԂȂ΁A
            if (isChecked)
            {
                // checkedImage Ԃ܂B
                return checkedImage;
            }
            // zo[ԂȂ΁A
            if (isHovered)
            {
                // hoveredImage Ԃ܂B
                return hoveredImage;
            }
            // p Image Ԃ܂B
            return Image;
        }
        #endregion

        #region I[o[Chꂽ\bh
        protected override void OnPaint(PaintEventArgs pevent)
        {
            // OtBbNX擾܂B
            Graphics g = pevent.Graphics;

            // `悷ׂC[W擾܂B
            Image image = GetImage();

            // `悷ׂC[Ŵ݂ł΁A
            if (image != null)
            {
                // Rg[Lł΁A
                if (this.Enabled)
                {
                    // ʏ̕`s܂B
                    g.DrawImage(image, 0, 0);
                }
                else
                {
                    // Ԃ̕`s܂B
                    ControlPaint.DrawImageDisabled(g, image, 0, 0, Color.Black);
                }
            }
            else
            {
                // œhԂ܂B
                g.FillRectangle(Brushes.Black, pevent.ClipRectangle);
            }
        }

        protected override void OnPaintBackground(PaintEventArgs pevent)
        {
            // ܂B
        }
        #endregion

        #region vpeB
        private Image hoveredImage = null;
        /// <summary>
        /// zo[Ԃ̎Ƀ{^ Rg[ɕ\C[W擾܂͐ݒ肵܂B
        /// </summary>
        [Category("\")]
        [Description("zo[Ԃ̎ɃRg[ɕ\C[WłB")]
        [DefaultValue(null)]
        public Image HoveredImage
        {
            get
            {
                return hoveredImage;
            }
            set
            {
                hoveredImage = value;
            }
        }

        private Image checkedImage = null;
        /// <summary>
        /// `FbNԂ̎Ƀ{^ Rg[ɕ\C[W擾܂͐ݒ肵܂B
        /// </summary>
        [Category("\")]
        [Description("`FbNԂ̎ɃRg[ɕ\C[WłB")]
        [DefaultValue(null)]
        public Image CheckedImage
        {
            get
            {
                return checkedImage;
            }
            set
            {
                checkedImage = value;
            }
        }
        #endregion
        //! mixin ImageButtonModule end
    }
}
