using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace YaneMixer
{
    using System;
    using System.IO;
    using System.Text;
    using System.Collections.Generic;

    public class Mixin
    {
        StreamWriter writer;

        public void run(string directory, StreamWriter writer)
        {
            this.writer = writer;
            // 2 pass ŉ͂s
            string[] filelist = Directory.GetFiles(directory, "*.cs", SearchOption.AllDirectories);
            foreach (string filename in filelist) readSourceFile(filename, true); // parse
            if (bError) return; // parseerrorЂƂłupdate͒f
            foreach (string filename in filelist) readSourceFile(filename, false);// update
            if (!bError)
                Console.WriteLine("mixin preprocessor I");
        }

        class ModuleData
        {
            public string modulename;// module
            public string contents;  // modulee
        }

        List<ModuleData> moduleDataList = new List<ModuleData>();

        const string START_REGION_STRING = "#region --- mixin automatically generated.";
        const string END_REGION_STRING = "#endregion --- mixin automatically generated.";

        /*
         * bRead : truêƂparse only , falsêƂ source fileupdates
         */
        void readSourceFile(string filename, bool bRead)
        {
            using (FileStream fs = File.OpenRead(filename))
            using (StreamReader sr = new StreamReader(fs, Encoding.Default))
            {
                StreamWriter sw = bRead ? null : writer;
                string super = "";  // p
                string line1, line2; // line1:HO1sBline2:H1s
                bool bModuleFeed = false; // Module̒`ł邱Ƃ\tO
                bool bWriteSkip = false; // ݂skiptO
                int linecount; // \[X̍s
                for (linecount = 1; (line1 = sr.ReadLine()) != null; ++linecount)
                {
                    line2 = line1.Trim().Replace(",", " ");
                    // \[XɁAOo͂mixinregion΂̕skip
                    if (!bRead)
                    {
                        if (!bWriteSkip && line2 == START_REGION_STRING)
                        { bWriteSkip = true; continue; }
                        if (bWriteSkip && line2 == END_REGION_STRING)
                        { bWriteSkip = false; continue; }
                    }
                    if (line2.StartsWith("//!"))
                    {
                        line2 = line2.Substring(3).Trim();
                        string[] args = line2.Split(new char[] { ' ', '\t' });
                        if (args.Length < 3 || args[0] != "mixin") continue;
                        /*
                         *  mix-in \
                         *    //! mixin [mixinΏۃNX] include [W[]
                         *        [W[]̓̕J}ŋ؂ĕƂł
                         *    //! mixin [`郂W[] start
                         *    //! mixin [`郂W[] end
                         */

                        switch (args[2])
                        {
                            case "include":
                                {
                                    if (bModuleFeed)
                                    {
                                        errorOut(filename, linecount, line1,
                                            "mixiñW[`includeoB");
                                        return;
                                    }
                                    if (bRead) break;
                                    if (args.Length < 3)
                                    {
                                        errorOut(filename, linecount, line1,
                                            "mixinincludeĂmodulesB");
                                        return;
                                    }
                                    // classname = args[2] , arg[4]` ǉׂModule
                                    sw.WriteLine("  " + START_REGION_STRING);
                                    sw.WriteLine("  partial class " + args[1] + (String.IsNullOrEmpty(super) ? "" : ":" + super));
                                    sw.WriteLine("  {");
                                    for (int i = 3; i < args.Length; ++i)
                                    {
                                        bool bFound = false;
                                        foreach (ModuleData data in moduleDataList)
                                            if (data.modulename == args[i])
                                            {
                                                sw.Write(data.contents);
                                                bFound = true;
                                                break;
                                            }
                                        if (!bFound)
                                        {
                                            errorOut(filename, linecount, line1,
                                                "mixinŐ錾ĂȂW[includeĂB");
                                            return;
                                        }
                                    }
                                    sw.WriteLine("  }");
                                    sw.WriteLine("  " + END_REGION_STRING);
                                    break;
                                }

                            case "start":
                                {
                                    if (!bRead) break;
                                    if (bModuleFeed)
                                    {
                                        errorOut(filename, linecount, line1,
                                            "mixiñW[`ɓq̃W[`oB");
                                        return;
                                    }
                                    foreach (ModuleData data in moduleDataList)
                                        if (data.modulename == args[1])
                                        {
                                            errorOut(filename, linecount, line1,
                                                "mixin郂W[̏d`B");
                                            return;
                                        }

                                    {
                                        ModuleData data = new ModuleData();
                                        data.modulename = args[1];
                                        moduleDataList.Add(data);
                                    }
                                    bModuleFeed = true; // Modulecontentsǂݍݒ
                                    continue;
                                }

                            case "end":
                                {
                                    if (!bRead) break;
                                    if (!bModuleFeed)
                                    {
                                        errorOut(filename, linecount, line1,
                                            "mixiñW[`łȂ̂ɃW[I[oB");
                                        return;
                                    }
                                    if (args[1] != moduleDataList[moduleDataList.Count - 1].modulename)
                                    {
                                        errorOut(filename, linecount, line1,
                                            "mixiñW[`ŊJnƈقȂ郂W[ŏI[B");
                                        return;
                                    }
                                    bModuleFeed = false;
                                    break;
                                }
                        }
                    }
                    else
                    {
                        Match m = Regex.Match(line2, @"class\s+[^:]+:(.*)");
                        if (m.Success)
                            super = m.Groups[1].Value;
                    }
                    if (bModuleFeed)
                    {
                        ModuleData data = moduleDataList[moduleDataList.Count - 1];
                        data.contents += line1 + "\r\n";
                    }
                }
                if (bModuleFeed)
                {
                    errorOut(filename, linecount, line1,
                        "mixiñW[`Ƀ\[Xt@CIB");
                    return;
                }
            }
        }

        bool bError = false;
        // G[bZ[W̏o
        void errorOut(string filename, int linecount, string linebuffer, string message)
        {
            Console.WriteLine("mixin preprocessorError!!");
            Console.WriteLine(filename + "(" + linecount.ToString() + ") : " + linebuffer + "\n" + message);
            bError = true;
        }
    }
}
